<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\MAN\Services\SetFilialSelecionada;

class SetFilialSelecionada {
    
    protected $dataSourceName = "operador";
    protected $setFilialSelecionadaService;

    public function __construct(Environment $environment, setFilialSelecionadaService $setFilialSelecionadaService) {
        $this->setFilialSelecionadaService = $setFilialSelecionadaService;
    }



    public function changeUserUnit(DTO\Request $request, DTO\Response $response) {
        try {
            $userRow = $this->getBuildedUserRow($request->getRow());
            $this->setFilialSelecionadaService->changeUserUnit($userRow);
            $response->addDataSet(new DataSet($this->dataSourceName, $userRow));
        } catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    private function getBuildedUserRow($row) {
        return array(
            "NRORG" => $row['nrorg'],
            "CDFILIAL" => $row['cdfilial'],
            "CDOPERADOR" => $this->setFilialSelecionadaService->getCdoperador()
        );
    }
}