<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class FaturamentoDayPartService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function fetchReport($conditions){
	 
	   if(isset($conditions['CDFILIAL']) && isset($conditions['DTPERIODO']) && isset($conditions['TIPORELATORIO'])){
	      
	      $params = array(
 	        ':CDFILIAL'       => implode('_', $conditions['CDFILIAL']),   
 	        ':DTENTRVENDAINI' => $conditions['DTPERIODO'][0],   
 	        ':DTENTRVENDAFIN' => $conditions['DTPERIODO'][1]
 	    );
      $params[':ALLFIEDLS'] = 'T';
      foreach($conditions as $key => $column){
	       if(strpos($key, '|')){
            $params[':ALLFIEDLS'] = $column[0]['_ALL'];
        }
      }
	      
 	    if($conditions['TIPORELATORIO'] === "A"){
 	        try{
 	            return $this->entityManager->getConnection()->fetchAll(self::FATURAMENTO_DAYPART_QRY_ANALY, $params);
 	        } catch (\Exception $e){
              throw $e;
          }
 	    }
 	    else if($conditions['TIPORELATORIO'] === "S"){
 	        try {
 	            return $this->entityManager->getConnection()->fetchAll(self::FATURAMENTO_DAYPART_QRY_SYNTH, $params);
 	        } catch (\Exception $e){
              throw $e;
          }
 	    }
	   }else{
	     return array();
	   }
	}

	
	const FATURAMENTO_DAYPART_QRY_ANALY = "
	   SELECT *  FROM ( SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
       TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI1DAYPART, FILOCA.HRFIN1DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
       '1'||' - '||FILOCA.HRINI1DAYPART|| ' às '||FILOCA.HRFIN1DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
       TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
       TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
      FROM VENDASINT V
       JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
               FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
             FROM CAIXA C
              JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                      FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                    FROM LOJA L
                     JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                           FROM PARAVEND P
                            JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                  FROM FILIAL F
                                  WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0) FI 
                            ON P.CDFILIAL = FI.CDFILIAL) FIPA
                     ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
              ON C.CDFILIAL = FILO.CDFILIAL 
               AND C.CDLOJA = FILO.CDLOJA) FILOCA 
       ON V.CDCAIXA = FILOCA.CDCAIXA
        AND V.CDLOJA = FILOCA.CDLOJA
        AND V.CDFILIAL = FILOCA.CDFILIAL
      WHERE V.IDSITUVENDA = 'O'             
       AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
       AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI1DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN1DAYPART, 'HH24:MI:SS' )  ) 
    GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI1DAYPART, FILOCA.HRFIN1DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
    
    UNION ALL
    
    SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
       TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI2DAYPART, FILOCA.HRFIN2DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
       '2'||' - '||FILOCA.HRINI2DAYPART|| ' às '||FILOCA.HRFIN2DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
       TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
       TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
      FROM VENDASINT V
       JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
               FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
             FROM CAIXA C
              JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                      FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                    FROM LOJA L
                     JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                           FROM PARAVEND P
                            JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                  FROM FILIAL F
                                  WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                            ON P.CDFILIAL = FI.CDFILIAL) FIPA
                     ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
              ON C.CDFILIAL = FILO.CDFILIAL 
               AND C.CDLOJA = FILO.CDLOJA) FILOCA 
       ON V.CDCAIXA = FILOCA.CDCAIXA
        AND V.CDLOJA = FILOCA.CDLOJA
        AND V.CDFILIAL = FILOCA.CDFILIAL
      WHERE V.IDSITUVENDA = 'O'             
       AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
       AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI2DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN2DAYPART, 'HH24:MI:SS' )  ) 
    GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI2DAYPART, FILOCA.HRFIN2DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
    
    UNION ALL
    
    SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
       TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI3DAYPART, FILOCA.HRFIN3DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
       '3'||' - '||FILOCA.HRINI3DAYPART|| ' às '||FILOCA.HRFIN3DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
       TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
       TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
      FROM VENDASINT V
       JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
               FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
             FROM CAIXA C
              JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                      FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                    FROM LOJA L
                     JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                           FROM PARAVEND P
                            JOIN (SELECT F.CDFILIAL, F.NMFILIAL 
                                  FROM FILIAL F
                                  WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0) FI 
                            ON P.CDFILIAL = FI.CDFILIAL) FIPA
                     ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
              ON C.CDFILIAL = FILO.CDFILIAL 
               AND C.CDLOJA = FILO.CDLOJA) FILOCA 
       ON V.CDCAIXA = FILOCA.CDCAIXA
        AND V.CDLOJA = FILOCA.CDLOJA
        AND V.CDFILIAL = FILOCA.CDFILIAL
      WHERE V.IDSITUVENDA = 'O'             
       AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
       AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI3DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN3DAYPART, 'HH24:MI:SS' )  ) 
    GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI3DAYPART, FILOCA.HRFIN3DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
    
    UNION ALL
    
    SELECT SUM(P4.NRCUPONS) AS NRCUPONS, P4.CDFILIAL, SUBSTR(P4.DTENTRVENDA, 0, 10) AS DTENTRVENDA, SUM(P4.ACR) AS ACR, SUM(P4.VRTXENTREGA) AS VRTXENTREGA,
      SUM(P4.VRDESCONTO) AS VRDESCONTO, SUM(P4.VRREPIQUEVENDA) AS VRREPIQUEVENDA, P4.HRINI4DAYPART, P4.HRFIN4DAYPART, SUM(P4.NRPESMESAVENDA) AS NRPESMESAVENDA,
      P4.PERIODO, SUM(P4.VRGORJETA) AS VRGORJETA, SUM(P4.TOTAL_ACOMULADO) AS TOTAL_ACOMULADO, SUM(P4.VR_BRUTO) AS VALOR_BRUTO, P4.CDFILIAL||' '||P4.NMFILIAL AS LABELFILIAL,
      TRUNC((SUM(P4.VR_BRUTO) / SUM(P4.NRPESMESAVENDA)), 2) AS TICKETMEDIO
    FROM (
      SELECT V.IDSITUVENDA, COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
         V.DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
         TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, FILOCA.NMFILIAL, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, 
         FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
         '4'||' - '||FILOCA.HRINI4DAYPART|| ' às '||FILOCA.HRFIN4DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
         TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VR_BRUTO
        FROM VENDASINT V
         JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                 FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
               FROM CAIXA C
                JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                        FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                      FROM LOJA L
                       JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                             FROM PARAVEND P
                              JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                    FROM FILIAL F
                                    WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0) FI 
                              ON P.CDFILIAL = FI.CDFILIAL) FIPA
                       ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                ON C.CDFILIAL = FILO.CDFILIAL 
                 AND C.CDLOJA = FILO.CDLOJA) FILOCA 
         ON V.CDCAIXA = FILOCA.CDCAIXA
          AND V.CDLOJA = FILOCA.CDLOJA
          AND V.CDFILIAL = FILOCA.CDFILIAL
        WHERE V.IDSITUVENDA = 'O'             
         AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
         AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI4DAYPART, 'HH24:MI:SS' ) AND TO_DATE(TO_CHAR('23:59:59'), 'HH24:MI:SS' ))
      GROUP BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.NMFILIAL, 
      FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART 
      
      UNION ALL
      
      
      SELECT V.IDSITUVENDA, COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
         V.DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
         TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, FILOCA.NMFILIAL, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, 
         FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
         '4'||' - '||FILOCA.HRINI4DAYPART|| ' às '||FILOCA.HRFIN4DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
         TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VR_BRUTO
        FROM VENDASINT V
         JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                 FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
               FROM CAIXA C
                JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                        FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                      FROM LOJA L
                       JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                             FROM PARAVEND P
                              JOIN (SELECT F.CDFILIAL, F.NMFILIAL 
                                    FROM FILIAL F
                                    WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                              ON P.CDFILIAL = FI.CDFILIAL) FIPA
                       ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                ON C.CDFILIAL = FILO.CDFILIAL 
                 AND C.CDLOJA = FILO.CDLOJA) FILOCA 
         ON V.CDCAIXA = FILOCA.CDCAIXA
          AND V.CDLOJA = FILOCA.CDLOJA
          AND V.CDFILIAL = FILOCA.CDFILIAL
        WHERE V.IDSITUVENDA = 'O'             
         AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
         AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(TO_CHAR('00:00:00'), 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN4DAYPART, 'HH24:MI:SS' ))
      GROUP BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.NMFILIAL, 
      FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART  
    ) P4
    GROUP BY P4.CDFILIAL, P4.DTENTRVENDA, P4.NMFILIAL, P4.HRINI4DAYPART, P4.HRFIN4DAYPART, P4.PERIODO, P4.CDFILIAL||' '||P4.NMFILIAL
    ORDER BY CDFILIAL, DTENTRVENDA)
    WHERE (CDFILIAL||LABELFILIAL||PERIODO||DTENTRVENDA||VALOR_BRUTO||VRDESCONTO||TOTAL_ACOMULADO||VRREPIQUEVENDA||VRTXENTREGA||VRGORJETA||ACR||NRPESMESAVENDA||TICKETMEDIO like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )
	";
	
	const FATURAMENTO_DAYPART_QRY_SYNTH = "
       SELECT *  FROM ( SELECT 'TODOS' AS CDFILIAL, T.DTENTRVENDA, 'TODOS' AS NMFILIAL, 'TODOS' AS LABELFILIAL, T.HRINI1DAYPART, T.HRFIN1DAYPART, T.PERIODO,
           SUM(T.NRCUPONS) AS NRCUPONS, SUM(T.VRDESCONTO) AS VRDESCONTO, SUM(T.TOTAL_ACOMULADO) AS TOTAL_ACOMULADO, SUM(T.VALOR_BRUTO) AS VALOR_BRUTO, SUM(T.ACR) AS ACR,
           SUM(T.VRREPIQUEVENDA) AS VRREPIQUEVENDA, SUM(T.NRPESMESAVENDA) AS NRPESMESAVENDA, SUM(T.VRTXENTREGA) AS VRTXENTREGA, SUM(T.VRGORJETA) AS VRGORJETA,
           (SUM(T.TOTAL_ACOMULADO) / SUM(T.NRPESMESAVENDA) ) AS TICKETMEDIO
        FROM 
            (SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
               TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI1DAYPART, FILOCA.HRFIN1DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
               '1'||' - '||FILOCA.HRINI1DAYPART|| ' às '||FILOCA.HRFIN1DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
               TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
               TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
              FROM VENDASINT V
               JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                       FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
                     FROM CAIXA C
                      JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                              FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                            FROM LOJA L
                             JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                                   FROM PARAVEND P
                                    JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                          FROM FILIAL F
                                          WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                                    ON P.CDFILIAL = FI.CDFILIAL) FIPA
                             ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                      ON C.CDFILIAL = FILO.CDFILIAL 
                       AND C.CDLOJA = FILO.CDLOJA) FILOCA 
               ON V.CDCAIXA = FILOCA.CDCAIXA
                AND V.CDLOJA = FILOCA.CDLOJA
                AND V.CDFILIAL = FILOCA.CDFILIAL
              WHERE V.IDSITUVENDA = 'O'             
               AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
               AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI1DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN1DAYPART, 'HH24:MI:SS' )  ) 
            GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI1DAYPART, FILOCA.HRFIN1DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
            
            UNION ALL
            
            SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
               TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI2DAYPART, FILOCA.HRFIN2DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
               '2'||' - '||FILOCA.HRINI2DAYPART|| ' às '||FILOCA.HRFIN2DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
               TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
               TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
              FROM VENDASINT V
               JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                       FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
                     FROM CAIXA C
                      JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                              FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                            FROM LOJA L
                             JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                                   FROM PARAVEND P
                                    JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                          FROM FILIAL F
                                          WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                                    ON P.CDFILIAL = FI.CDFILIAL) FIPA
                             ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                      ON C.CDFILIAL = FILO.CDFILIAL 
                       AND C.CDLOJA = FILO.CDLOJA) FILOCA 
               ON V.CDCAIXA = FILOCA.CDCAIXA
                AND V.CDLOJA = FILOCA.CDLOJA
                AND V.CDFILIAL = FILOCA.CDFILIAL
              WHERE V.IDSITUVENDA = 'O'             
               AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
               AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI2DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN2DAYPART, 'HH24:MI:SS' )  ) 
            GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI2DAYPART, FILOCA.HRFIN2DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
            
            UNION ALL
            
            SELECT COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDFILIAL, SUBSTR(V.DTENTRVENDA, 0, 10) AS DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
               TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, FILOCA.HRINI3DAYPART, FILOCA.HRFIN3DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
               '3'||' - '||FILOCA.HRINI3DAYPART|| ' às '||FILOCA.HRFIN3DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
               TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VALOR_BRUTO, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL AS LABELFILIAL,
               TRUNC((SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND) )/ SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS TICKETMEDIO
              FROM VENDASINT V
               JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                       FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
                     FROM CAIXA C
                      JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                              FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                            FROM LOJA L
                             JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                                   FROM PARAVEND P
                                    JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                          FROM FILIAL F
                                          WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                                    ON P.CDFILIAL = FI.CDFILIAL) FIPA
                             ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                      ON C.CDFILIAL = FILO.CDFILIAL 
                       AND C.CDLOJA = FILO.CDLOJA) FILOCA 
               ON V.CDCAIXA = FILOCA.CDCAIXA
                AND V.CDLOJA = FILOCA.CDLOJA
                AND V.CDFILIAL = FILOCA.CDFILIAL
              WHERE V.IDSITUVENDA = 'O'             
               AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
               AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI3DAYPART, 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN3DAYPART, 'HH24:MI:SS' )  ) 
            GROUP BY FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.HRINI3DAYPART, FILOCA.HRFIN3DAYPART, FILOCA.CDFILIAL||' '||FILOCA.NMFILIAL
            
            UNION ALL
            
            SELECT SUM(P4.NRCUPONS) AS NRCUPONS, P4.CDFILIAL, SUBSTR(P4.DTENTRVENDA, 0, 10) AS DTENTRVENDA, SUM(P4.ACR) AS ACR, SUM(P4.VRTXENTREGA) AS VRTXENTREGA,
              SUM(P4.VRDESCONTO) AS VRDESCONTO, SUM(P4.VRREPIQUEVENDA) AS VRREPIQUEVENDA, P4.HRINI4DAYPART, P4.HRFIN4DAYPART, SUM(P4.NRPESMESAVENDA) AS NRPESMESAVENDA,
              P4.PERIODO, SUM(P4.VRGORJETA) AS VRGORJETA, SUM(P4.TOTAL_ACOMULADO) AS TOTAL_ACOMULADO, SUM(P4.VR_BRUTO) AS VALOR_BRUTO, P4.CDFILIAL||' '||P4.NMFILIAL AS LABELFILIAL,
              TRUNC((SUM(P4.VR_BRUTO) / SUM(P4.NRPESMESAVENDA)), 2) AS TICKETMEDIO
            FROM (
              SELECT V.IDSITUVENDA, COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                 V.DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
                 TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, FILOCA.NMFILIAL, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, 
                 FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
                 '4'||' - '||FILOCA.HRINI4DAYPART|| ' às '||FILOCA.HRFIN4DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
                 TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VR_BRUTO
                FROM VENDASINT V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                         FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
                       FROM CAIXA C
                        JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                                FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                              FROM LOJA L
                               JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                                     FROM PARAVEND P
                                      JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                            FROM FILIAL F
                                            WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                                      ON P.CDFILIAL = FI.CDFILIAL) FIPA
                               ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                        ON C.CDFILIAL = FILO.CDFILIAL 
                         AND C.CDLOJA = FILO.CDLOJA) FILOCA 
                 ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                WHERE V.IDSITUVENDA = 'O'             
                 AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
                 AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(FILOCA.HRINI4DAYPART, 'HH24:MI:SS' ) AND TO_DATE(TO_CHAR('23:59:59'), 'HH24:MI:SS' ))
              GROUP BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.NMFILIAL, 
              FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART 
              
              UNION ALL
              
              
              SELECT V.IDSITUVENDA, COUNT(V.NRSEQVENDA) AS NRCUPONS, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                 V.DTENTRVENDA, TRUNC(SUM(V.VRTOTACRITVEND)- SUM(V.VRTXSERVTOT) -SUM(V.VRTXENTREGATOT), 2)  AS ACR, TRUNC(SUM(V.VRTXENTREGATOT),2) AS VRTXENTREGA,
                 TRUNC(SUM(V.VRTOTDESITVEND), 2) AS VRDESCONTO, FILOCA.NMFILIAL, TRUNC(SUM(V.VRREPIQUEVENDA), 2) AS VRREPIQUEVENDA, 
                 FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART, TRUNC(SUM(NVL(V.NRPESMESAVENDA, 1)), 2) AS NRPESMESAVENDA, 
                 '4'||' - '||FILOCA.HRINI4DAYPART|| ' às '||FILOCA.HRFIN4DAYPART AS PERIODO, TRUNC(SUM(V.VRTXSERVTOT), 2) AS VRGORJETA, TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT), 2) AS TOTAL_ACOMULADO,
                 TRUNC(SUM(V.VRTOTVEND )+SUM(V.VRTXENTREGATOT) - SUM(V.VRTOTDESITVEND), 2) AS VR_BRUTO
                FROM VENDASINT V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL,FILO.HRINI1DAYPART, FILO.HRINI2DAYPART,
                         FILO.HRINI3DAYPART, FILO.HRINI4DAYPART, FILO.HRFIN1DAYPART, FILO.HRFIN2DAYPART, FILO.HRFIN3DAYPART, FILO.HRFIN4DAYPART
                       FROM CAIXA C
                        JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, L.CDPRODTAXASERV, FIPA.HRINI1DAYPART, FIPA.HRINI2DAYPART, FIPA.HRINI3DAYPART,
                                FIPA.HRINI4DAYPART, FIPA.HRFIN1DAYPART, FIPA.HRFIN2DAYPART, FIPA.HRFIN3DAYPART, FIPA.HRFIN4DAYPART
                              FROM LOJA L
                               JOIN (SELECT P.HRINI1DAYPART, P.HRINI2DAYPART, P.HRINI3DAYPART, P.HRINI4DAYPART, P.HRFIN1DAYPART, P.HRFIN2DAYPART, P.HRFIN3DAYPART, P.HRFIN4DAYPART, FI.CDFILIAL, FI.NMFILIAL
                                     FROM PARAVEND P
                                      JOIN (SELECT F.CDFILIAL, F.NMFILIAL
                                            FROM FILIAL F
                                            WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 ) FI 
                                      ON P.CDFILIAL = FI.CDFILIAL) FIPA
                               ON L.CDFILIAL = FIPA.CDFILIAL) FILO 
                        ON C.CDFILIAL = FILO.CDFILIAL 
                         AND C.CDLOJA = FILO.CDLOJA) FILOCA 
                 ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                WHERE V.IDSITUVENDA = 'O'             
                 AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN   
                 AND (TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(TO_CHAR('00:00:00'), 'HH24:MI:SS' ) AND TO_DATE(FILOCA.HRFIN4DAYPART, 'HH24:MI:SS' ))
              GROUP BY V.IDSITUVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, V.DTENTRVENDA, FILOCA.NMFILIAL, 
              FILOCA.HRINI4DAYPART, FILOCA.HRFIN4DAYPART  
            ) P4
            GROUP BY P4.CDFILIAL, P4.DTENTRVENDA, P4.NMFILIAL, P4.HRINI4DAYPART, P4.HRFIN4DAYPART, P4.PERIODO, P4.CDFILIAL||' '||P4.NMFILIAL
            ) T  
        GROUP BY 'TODOS', T.DTENTRVENDA, T.HRINI1DAYPART, T.HRFIN1DAYPART, T.PERIODO
        ORDER BY T.DTENTRVENDA)
        WHERE (CDFILIAL||LABELFILIAL||PERIODO||DTENTRVENDA||VALOR_BRUTO||VRDESCONTO||TOTAL_ACOMULADO||VRREPIQUEVENDA||VRTXENTREGA||VRGORJETA||ACR||NRPESMESAVENDA||TICKETMEDIO like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )
    ";
}