<?php
namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

/********* Atenção *************/
// MOVICLIE - Debito Consumidor 
/*******************************/

class RecalculoSaldoConsDebService extends StoredProcedure {

    public function __construct(Connection $connection, $entityManager) {
        parent::__construct($connection, 'ATUALIZA_SALDO_CONS');
        $this->entityManager             = $entityManager;     
    }
    public function selecionaConsumidores($parameters, $params) {
        $DATAPIECES = explode('/', $params['DTRECALCULO']);
        $DATAPARAM = $params['DTRECALCULO'].' '.$params['HORAFIELD'];
        $OPERADORPARAM = $params['CDOPERADOR'];
        $FILIAL = $params['CDFILIAL'];
        $resposta = $this->entityManager->getConnection()->executeQuery(self::SELECIONA_CONSUMIDOR, $parameters)->fetchAll();    
        foreach($resposta as $resp){
            $CONSUMIDOR = $resp['CDCONSUMIDOR'];
            $CLIENTE = $resp['CDCLIENTE'];
            self::AtualizaSaldoCons($FILIAL, $CLIENTE, $CONSUMIDOR, $DATAPARAM, $OPERADORPARAM);
        }
    }
    
    /**
     * @param 
     * @param $params
     * @param $nrorg
     * @return Execução
     */
    public function AtualizaSaldoCons($FILIAL, $CLIENTE, $CONSUMIDOR, $DATAPARAM, $OPERADORPARAM){
        try {
            set_time_limit(120);
            $CDFILIAL  = $FILIAL;
            $CDCLIENTE  = $CLIENTE;
            $CDCONSUMIDOR  = $CONSUMIDOR;
            $DATA = $DATAPARAM;
            $OPERADOR = $OPERADORPARAM;
            $this->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR, strlen($CDFILIAL)));
            $this->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $CDCLIENTE, Param::PARAM_TYPE_STR, strlen($CDCLIENTE)));
            $this->addParam(new Param('P_CDCONSUMIDOR', Param::PARAM_INPUT, $CDCONSUMIDOR, Param::PARAM_TYPE_STR, strlen($CDCONSUMIDOR)));
            $this->addParam(new Param('P_DATA', Param::PARAM_INPUT, $DATA, Param::PARAM_TYPE_STR, strlen($DATA)));
            $this->addParam(new Param('P_OPERADOR', Param::PARAM_INPUT, $OPERADOR, Param::PARAM_TYPE_STR, strlen($OPERADOR)));
            $this->execute();
            $this->params = array();
            return 'OK';
        } catch (Exception $e) {
            throw $e;
        }
        
        
    }
    
    const SELECIONA_CONSUMIDOR = "SELECT DISTINCT CO.CDCONSUMIDOR, CO.CDCLIENTE FROM CONSUMIDOR CO, MOVICLIE MO WHERE ((INSTR(:P_CDCLIENTE, CO.CDCLIENTE) > 0) OR (:P_TCDCLIENTE = 'T')) AND ((INSTR(:P_CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) > 0) OR (:P_TCDCONSUMIDOR = 'T')) AND ((INSTR(:P_CDTIPOCONS, CO.CDTIPOCONS) > 0) OR (:P_TCDTIPOCONS = 'T')) AND (MO.CDCLIENTE = CO.CDCLIENTE ) AND (MO.CDCONSUMIDOR = CO.CDCONSUMIDOR)";
}