<?php
namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;

class TipoRecebimentoService {

    /**
     * @var Repository\TipoRecebimento
     */
    protected $tipoRecebimentoRepository;
    protected $connection;

    public function __construct(Factories\TipoRecebimentoRepository $tipoRecebimentoRepository, Connection $connection) {
        $this->tipoRecebimentoRepository = $tipoRecebimentoRepository;
        $this->connection = $connection;
    }

    public function getNextNumParam() {
        $numRow = $this->tipoRecebimentoRepository->getMaxNumParam();
        $num = $numRow[0]['MAX_NUM'];
        return !is_null($num) ? ++$num : 1;
    }

    public function checkParam($cod) {
        $codQuery = $this->tipoRecebimentoRepository->checkParam($cod);        
        return ($codQuery) ? $codQuery['NRPARAM'] : false;
    }

    public function deleta($cdtipo, $nrorg, $id, $dtult, $nrult, $cdult) {
        $params = array(
            "IDATIVO" => $id,
            "DTULTATU" => $dtult,
            "NRORGULTATU" => $nrult,
            "CDOPERULTATU" => $cdult,
            "CDTIPORECE" => $cdtipo,
            "NRORG" => $nrorg
     	); 
        $this->connection->executeUpdate(Utilities\Query::UPDATE_TIPORECE,$params);
    }

    public function findCd($cdtipo, $nrorg){
        $params = array(
            "CDTIPORECE" => $cdtipo,
            "NRORG" => $nrorg
     	);  
        return $this->connection->fetchAll(Utilities\Query::GET_CDTIPORECE,$params);
    }

    public function getNextId(){
        $nextId = $this->connection->fetchAll(Utilities\Query::GET_MAXNRRELAATRIBUTOTIPORECE);
        if (is_null($nextId[0]['MAX_NUM'])){
            $nextId = 1;
        } else {
            $nextId = $nextId[0]['MAX_NUM'];
            $nextId++;
        }
        return $nextId;
    }

    public function getTipoTrocoNextId() {
        $nextId = $this->connection->fetchAll(Utilities\Query::GET_MAXNRRELTIPOTROCO)[0]['NRRELTIPOTROCO'];
        $nextId++;
        return $nextId;
    }

    public function findTiposTroco($nrorg, $cdtipo) {
        $params = array(
            "CDTIPORECE" => $cdtipo,
            "NRORG" => $nrorg
     	); 
        return $this->connection->fetchAll(Utilities\Query::GET_TIPORECE_TIPOTROCOS,$params);
    }
} 